'*******************************************************************************
'Display Driver IC ILI9325D 240x320 Pixel
'Modus 8Bit or 16Bit
'Landscape or Portrait
'
'Bascom version 2.0.7.6
'Date 12.06.2013
'
'Autor: Hkipnik@aol.com
'
'Copyright by Hkipnik@aol.com
'
'*******************************************************************************

$nocompile


Const Driver_code_read = $00
Const Start_oscillation = $00
Const Driver_output_control = $01
Const Lcd_driving_control = $02
Const Entry_mode = $03
Const Horizontal_gram_address = $20
Const Vertical_gram_address = $21
Const Write_data_to_gram = $22
Const Horizontal_add_start_position = $50
Const Horizontal_add_end_position = $51
Const Vertical_add_start_position = $52
Const Vertical_add_end_position = $53
Const Driver_output_control_2 = $60
Const Base_image_display_control = $61
Const Vertical_scroll_control = $6a
Const Partial_image_1_display_position = $80
Const Partial_image_1_area_start_line = $81
Const Partial_image_1_area_end_line = $82
Const Partial_image_2_display_position = $83
Const Partial_image_2_area_start_line = $84
Const Partial_image_2_area_end_line = $85


Const Pi = 3.14159265358979

'-------------------------------------------------------------------------------
'pre define Colors
'-------------------------------------------------------------------------------
'neue Farben
Const Transparent = &H1000
Const Aliceblue = &HF7DF
Const Antiquewhite = &HFF5A
Const Aqua = &H07FF
Const Aquamarine = &H7FFA
Const Azure = &HF7FF
Const Beige = &HF7BB
Const Bisque = &HFF38
Const Black = &H0000
Const Blanchedalmond = &HFF59
Const Blue = &H001F
Const Blueviolet = &H895C
Const Brown = &HA145
Const Burlywood = &HDDD0
Const Cadetblue = &H5CF4
Const Chartreuse = &H7FE0
Const Chocolate = &HD343
Const Coral = &HFBEA
Const Cornflowerblue = &H64BD
Const Cornsilk = &HFFDB
Const Crimson = &HD8A7
Const Cyan = &H07FF
Const Darkblue = &H0011
Const Darkcyan = &H0451
Const Darkgoldenrod = &HBC21
Const Darkgray = &HAD55
Const Darkgreen = &H0320
Const Darkkhaki = &HBDAD
Const Darkmagenta = &H8811
Const Darkolivegreen = &H5345
Const Darkorange = &HFC60
Const Darkorchid = &H9999
Const Darkred = &H8800
Const Darksalmon = &HECAF
Const Darkseagreen = &H8DF1
Const Darkslateblue = &H49F1
Const Darkslategray = &H2A69
Const Darkturquoise = &H067A
Const Darkviolet = &H901A
Const Deeppink = &HF8B2
Const Deepskyblue = &H05FF
Const Dimgray = &H6B4D
Const Dodgerblue = &H1C9F
Const Firebrick = &HB104
Const Floralwhite = &HFFDE
Const Forestgreen = &H2444
Const Fuchsia = &HF81F
Const Gainsboro = &HDEFB
Const Ghostwhite = &HFFDF
Const Gold = &HFEA0
Const Goldenrod = &HDD24
Const Gray = &H8410
Const Green = &H07E0
Const Green1 = &H0700
Const Greenyellow = &HAFE5
Const Honeydew = &HF7FE
Const Hotpink = &HFB56
Const Indianred = &HCAEB
Const Indigo = &H4810
Const Ivory = &HFFFE
Const Khaki = &HF731
Const Lavender = &HE73F
Const Lavenderblush = &HFF9E
Const Lawngreen = &H7FE0
Const Lemonchiffon = &HFFD9
Const Lightblue = &HAEDC
Const Lightcoral = &HF410
Const Lightcyan = &HE7FF
Const Lightgold = &HFFDA
Const Lightgreen = &H9772
Const Lightgrey = &HD69A
Const Lightpink = &HFDB8
Const Lightsalmon = &HFD0F
Const Lightseagreen = &H2595
Const Lightskyblue = &H867F
Const Lightslategray = &H7453
Const Lightsteelblue = &HB63B
Const Lightyellow = &HFFFC
Const Lime = &H07E0
Const Limegreen = &H3666
Const Linen = &HFF9C
Const Magenta = &HF81F
Const Maroon = &H8000
Const Mediumaquamarine = &H6675
Const Mediumblue = &H0019
Const Mediumorchid = &HBABA
Const Mediumpurple = &H939B
Const Mediumseagreen = &H3D8E
Const Mediumslateblue = &H7B5D
Const Mediumspringgreen = &H07D3
Const Mediumturquoise = &H4E99
Const Mediumvioletred = &HC0B0
Const Midnightblue = &H18CE
Const Mintcream = &HF7FF
Const Mistyrose = &HFF3C
Const Moccasin = &HFF36
Const Navajowhite = &HFEF5
Const Navy = &H0010
Const Oldlace = &HFFBC
Const Olive = &H8400
Const Olivedrab = &H6C64
Const Orange = &HFD20
Const Orangered = &HFA20
Const Orchid = &HDB9A
Const Palegoldenrod = &HEF55
Const Palegreen = &H9FD3
Const Paleturquoise = &HAF7D
Const Palevioletred = &HDB92
Const Papayawhip = &HFF7A
Const Peachpuff = &HFED7
Const Peru = &HCC27
Const Plum = &HDD1B
Const Powderblue = &HB71C
Const Purple = &H8010
Const Red = &HF800
Const Rosybrown = &HBC71
Const Royalblue = &H435C
Const Saddlebrown = &H8A22
Const Salmon = &HFC0E
Const Sandybrown = &HF52C
Const Seagreen = &H2C4A
Const Seashell = &HFFBD
Const Sienna = &HA285
Const Silver = &HC618
Const Skyblue = &H867D
Const Slateblue = &H6AD9
Const Slategray = &H7412
Const Snow = &HFFDF
Const Springgreen = &H07EF
Const Steelblue = &H4416
Const Teal = &H0410
Const Thistle = &HDDFB
Const Tomato = &HFB08
Const Turquoise = &H471A
Const Violet = &HEC1D
Const Wheat = &HF6F6
Const White = &HFFFF
Const Whitesmoke = &HF7BE
Const Yellow = &HFFE0
Const Yellowgreen = &H9E66


#if Driver_mode = 8
Data_disp Alias Porta
Rs_disp Alias Portd.7
Wr_disp Alias Portg.2
Cs_disp Alias Portg.1
Res_disp Alias Portg.0
'RD Pin pull it high
Config Data_disp = Output
#endif

#if Driver_mode = 16
                                        'Dispay DB0 - DB7
   Config Portc = Output
   Data_disp_low Alias Portc
                                            'Display DB8 - DB15
   Config Porta = Output
   Data_disp_high Alias Porta

   Rs_disp Alias Portd.7
   Wr_disp Alias Portg.2
   Cs_disp Alias Portg.1
   Res_disp Alias Portg.0
   Dim Rgb16 As Word
   Dim Rgb16_low As Byte At Rgb16 Overlay
   Dim Rgb16_high As Byte At Rgb16 + 1 Overlay
#endif

Config Rs_disp = Output
Config Cs_disp = Output
Config Wr_disp = Output
Config Res_disp = Output


Declare Sub Ili9325_init(byval Modus As Byte)
Declare Sub Ili9325_write_reg(byval Index As Byte , Byval Daten As Word)
Declare Sub Ili9325_write_data(byref Daten As Word)
Declare Sub Ili9325_select_reg(byval Index As Byte )


Declare Sub Lcd_scroll(byval Lines As Word )
Declare Sub Lcd_set_window(byval Xpos As Word , Byval Ypos As Word , Byval Xsize As Word , Byval Ysize As Word)
Declare Sub Lcd_negate(byval Art As Word )
Declare Sub Lcd_set_pixel(byval X1 As Word , Byval Y1 As Word , Byval Color As Word)
Declare Sub Lcd_set_cursor(byval X As Word , Y As Word )
Declare Sub Lcd_line(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Pen_width As Byte , Byval Color As Word)
Declare Sub Lcd_box(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Fill_color As Word , Byval Border_color As Word , Byval Fill As Byte , Byval Show_border As Byte)
Declare Sub Lcd_lineto(byval X As Word , Byval Y As Word , Byval Pen_width As Byte , Byval Color As Word , Byval Fill As Byte)
Declare Sub Lcd_moveto(byval X As Word , Byval Y As Word)

Declare Sub Fill_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color1 As Word)
Declare Sub Lcd_drawcircle(byval Centerx As Word , Byval Centery As Word , Byval Radius As Word , Byval Sides As Word , Byval Pen_width As Byte , Byval Color As Word , Byval Fill As Byte)
Declare Function Ili9325_trigfunctionx(byval Pointratio As Single) As Single
Declare Function Ili9325_trigfunctiony(byval Pointratio As Single) As Single
Declare Function Rgb_16(byval Rgb8 As Byte) As Word         'Convert the 8bit RRRGGGBB bgc data to 16 bit RRRRRGGGGGGBBBBB
Declare Sub Lcd_show_bgc(byval Xoffset As Word , Byval Yoffset As Word)       'Draw an Bascom BGC image on the lcd
Declare Sub Lcd_clear(byval Color As Word)
Declare Sub Lcd_pic_sram(byval Xs As Word , Byval Ys As Word , Byval Breite As Word , Byval Height As Word )
Declare Sub Lcd_text(byval S As String , Byval Xoffset As Word , Byval Yoffset As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word )
'Beta Test
Declare Sub Lcdtext(byval S As String , Byval Xoffset As Word , Byval Yoffset As Word , Byval Forecolor As Word , Byval Backcolor As Word , Byval Rotation As Byte , Byval Fontset As Byte)


#if Sd_card = 1
Declare Sub Lcd_draw_bmp(byval Filename As String , Byval Xpos As Word , Byval Ypos As Word)
#endif
#if Use_touch = 1
Declare Sub Lcd_read_touch()
#endif
#if Use_touch = 1
   Clock Alias Porth.3                                      'Touch Controler Clock Pin
   Cst Alias Porte.3                                        'Touch Controler CS Pin
   Dout Alias Portg.5                                       'Touch Controler Din Pin
   Din Alias Pine.5                                         'Touch Controler Dout Pin
   Config Din = Input
   Config Clock = Output
   Config Cst = Output
   Config Dout = Output
   Cst = 1

   Dim Touchx As Word
   Dim Touchy As Word
   Dim X_dout As Byte
   X_dout = &HD0
   Dim Y_dout As Byte
   Y_dout = &H90
   Dim Matrix_wert As Word
   Dim Ende As Byte
   Dim Z1 As Byte
   Dim Touch_flag As Byte

   Const X_offset = 330
   Const Y_offset = 420
   Const X_fact = 14.2
   Const Y_fact = 10.7
#endif

#if Sd_card = 1
 Dim Rgb_data(965) As Byte
 Dim Palette(1024) As Byte
 Dim Line_byte As Word
#endif

Dim X_pixel As Word , Y_pixel As Word
Dim Move_x As Word
Dim Move_y As Word
Dim Display_modus As Byte
Dim Penwidth As Byte , Radius As Word , Center As Word , Out_of_range As Byte
Dim Modus As Byte
Dim Direction As Word
Dim Pixelword As Word