'*******************************************************************************
'Display Driver IC ILI9325D 240x320 Pixel
'Modus 8Bit or 16Bit
'Landscape or Portrait
'
'Bascom version 2.0.7.6
'Date 12.06.2013
'
'Autor: Hkipnik@aol.com
'
'Copyright by Hkipnik@aol.com
'
' Text Rotation i Beta test
' der RD Pin vom Display an 3,3V legen
' Test whith Levelshifter
'*******************************************************************************
$regfile = "M2560def.dat"
$crystal = 16000000
$hwstack = 250
$swstack = 250
$framesize = 250


Config Com1 = 38400 , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0

'*******************************************************************************
'Display Mode
'*******************************************************************************
Const Driver_mode = 8                                       '8= 8Bit Modus 16= 16Bit Modus  16Bit noch nicht getestet
Const Sd_card = 1                                           'with SD Card = 1 -- without SD Card = 0
Const Use_touch = 0                                         'with Touch = 1 -- without Touch = 0
'*******************************************************************************
#if Sd_card = 1
    $include "Config_MMCSD_HC.bas"
    $include "Config_AVR-DOS.bas"
#endif

'*******************************************************************************
'Touch Interrupt
'*******************************************************************************
#if Use_touch = 1
   Config Pine.4 = Input
   Config Int4 = Falling
   On Int4 Touch_int
   Enable Int4
   Enable Interrupts
#endif
'*******************************************************************************

$include "ILI9325_declarations.inc"

#if Sd_card = 1
   Call Init_sd_card()                                      'Init SD Card
#endif
'*******************************************************************************
'Init the Display Portrait or Landscape
'*******************************************************************************
Call Ili9325_init(1)                                        '  2=Portrait   1=Landscape
'*******************************************************************************
'use for demo
Dim Xx1 As Word , Xx2 As Word , Yy1 As Word , Yy2 As Word , Zahl As Word
Dim Za As Word
Dim Color_array(10) As Word
Color_array(1) = Red
Color_array(2) = Green
Color_array(3) = Blue
Color_array(4) = White
Color_array(5) = Blue
Color_array(6) = Yellow
Color_array(7) = Cyan
Color_array(8) = Olive
Color_array(9) = Magenta
Color_array(10) = Red
Dim Temp_str As String * 20
Dim Help_str As String * 10
'*******************************************************************************

Do
  Print "Graphic ILI9325"
   Call Lcd_clear(red)
   '                         x    y    Fore    Back  Rotation  Font
   Call Lcdtext( "Hallo-0" , 2 , 10 , Black , Blue , 0 , 2)
   Call Lcdtext( "Hallo-1" , 100 , 1 , Black , Blue , 1 , 2)
   Call Lcdtext( "Hallo-2" , 215 , 100 , Black , Blue , 2 , 2)
   Call Lcdtext( "Hallo-3" , 10 , 239 , Black , Blue , 3 , 2)

   Call Lcd_clear(red)
   Call Lcdtext( "Hallo-0" , 2 , 10 , Black , Transparent , 0 , 3)
   Call Lcdtext( "Hallo-1" , 100 , 1 , Black , Transparent , 1 , 3)
   Call Lcdtext( "Hallo-2" , 215 , 100 , Black , Transparent , 2 , 3)
   Call Lcdtext( "Hallo-3" , 10 , 239 , Black , White , 3 , 3)

   Call Lcd_clear(red)
   Call Lcdtext( "Hallo-0" , 2 , 10 , Black , Transparent , 0 , 4)
   Call Lcdtext( "Hallo-1" , 100 , 1 , Black , Transparent , 1 , 4)
   Call Lcdtext( "Hallo-2" , 220 , 100 , Black , Transparent , 2 , 4)
   Call Lcdtext( "Hallo-3" , 10 , 239 , Black , White , 3 , 4)
   Call Lcd_box(50 , 200 , 100 , 239 , Yellow , Blue , 1 , 0)

   Call Lcd_clear(red)



#if Use_touch = 1
   Call Lcd_text( "<Test Touch>" , 10 , 210 , 2 , Yellow , Transparent)
   Call Lcd_box(10 , 20 , 60 , 70 , Blue , White , 1 , 1)
   Call Lcd_box(80 , 20 , 120 , 70 , Green , White , 1 , 1)
Do
   If Touch_flag = 1 Then
      Touchx = 0
      Touchy = 0
      Call Lcd_read_touch()

      Temp_str = "X "
      Help_str = Str(touchx)
      Temp_str = Temp_str + Format(help_str , "0000")
      Call Lcd_text(temp_str , 10 , 2 , 2 , Yellow , Black)

      Help_str = Str(touchy)
      Temp_str = "Y "
      Temp_str = Temp_str + Format(help_str , "0000")
      Call Lcd_text(temp_str , 110 , 2 , 2 , Yellow , Black)
      Call Fill_circle(touchx , Touchy , 2 , White)

     Select Case Touchx
       Case 10 To 60 :
          If Touchy > 20 And Touchy < 70 Then
           Ende = 1
          End If
     End Select

     Touch_flag = 0
   End If

   If Ende = 1 Then
     Ende = 0
     Exit Do
   End If

Loop
#endif

  Call Lcd_clear(silver)




   Call Lcd_text( "Test SD Bmp" , 10 , 10 , 2 , White , Red)
#if Sd_card = 1

 If Display_modus = 1 Then
    Call Lcd_draw_bmp( "047.bmp" , 0 , 0)                   '320x240
    Wait 3
 End If
      Call Lcd_clear(red)
 If Display_modus = 2 Then
    Call Lcd_draw_bmp( "016.bmp" , 1 , 1)                   '240x320
    Wait 3
    Call Lcd_draw_bmp( "708.bmp" , 1 , 1)
    Wait 3
 End If
   Call Lcd_clear(red)
#endif

   Call Lcd_text( "show Bin file" , 10 , 10 , 2 , White , Red)
   Restore Uhr1
   '                  X    Y  Breite Hhe
   Call Lcd_pic_sram(180 , 100 , 50 , 50)                   'Bin file
   Wait 1

   Restore Pic2
   Call Lcd_pic_sram(5 , 60 , 75 , 108)

   Wait 4
   Call Lcd_clear(red)
   Call Lcd_text( "Lcd Box" , 10 , 10 , 2 , White , Red)
   Call Lcd_box(50 , 50 , 100 , 100 , Yellow , Blue , 1 , 0)
   Call Lcd_box(100 , 100 , 200 , 200 , Silver , White , 1 , 1)

   Wait 1
   Call Lcd_clear(red)




   Call Lcd_clear(black)
   Call Lcd_text( "show BGC file" , 10 , 10 , 2 , White , Black)
   Restore Miky1
   Call Lcd_show_bgc(20 , 35)                               'BGC file
   Wait 3

   Call Lcd_clear(white)
   Call Lcd_text( "ili9325_line" , 10 , 10 , 2 , Black , White)

   For Za = 1 To 100
      Zahl = Rnd(10)
      Xx1 = 10 + Rnd(200)
      Xx2 = 10 + Rnd(200)
      Yy1 = 10 + Rnd(200)
      Yy2 = 10 + Rnd(200)
      Penwidth = Rnd(4)
    Call Lcd_line(xx1 , Yy1 , Xx2 , Yy2 , Penwidth , Color_array(zahl))
   Next
   Wait 5

   Call Lcd_clear(blue)
   Call Lcd_text( "ili9325_moveto" , 10 , 10 , 2 , White , Blue)
   Call Lcd_text( "ili9325_lineto" , 10 , 35 , 2 , White , Blue )

   Call Lcd_moveto(10 , 10)
   Call Lcd_lineto(240 , 200 , 1 , White , 0)
   Call Lcd_lineto(100 , 50 , 1 , White , 0)

   Wait 1
   Call Fill_circle(120 , 150 , 20 , Green)

   Wait 3
   Call Lcd_clear(blue)
   '                      x     y   redi sites pen col fill
   Call Lcd_drawcircle(120 , 100 , 30 , 150 , 1 , Red , 0)
   Call Lcd_drawcircle(50 , 50 , 30 , 200 , 1 , Yellow , 1)
   Wait 1
   Call Lcd_clear(blue)
   Call Lcd_drawcircle(120 , 160 , 50 , 200 , 1 , Yellow , 0)
   Wait 3

Loop
End
'*******************************************************************************
'*******************************************************************************
#if Use_touch = 1
'for touch
Touch_int:
Print "touch flag"
   Touch_flag = 1
Return
#endif

#if Sd_card = 1
$include "SD_card_init.inc"
#endif
$include "ILI9325_functions.inc"
$include "Rgb_data.inc"

$include "Font\font8x8.font"
$include "Font\font12x16.font"
$include "Font\font25x32.font"
$include "Font\crn20x24.font"

$inc Uhr1 , Nosize , "Bilder\uhr1.bin"
$inc Pic2 , Nosize , "Bilder\75x108.bin"

Miky1:
$bgf "Bilder\miky1.bgc"